import { IgcHTMLElement } from "igniteui-webcomponents-core";
import { DashboardTileCustomization } from "./DashboardTileCustomization";
import { TypeRegistrar } from "igniteui-webcomponents-core";
import { NamePatcher, getAllPropertyNames, fromSpinal, toSpinal, ensureBool, initializePropertiesFromCss } from "igniteui-webcomponents-core";
import { RegisterElementHelper } from "igniteui-webcomponents-core";
export let IgcDashboardTileCustomizationComponent = /*@__PURE__*/ (() => {
    class IgcDashboardTileCustomizationComponent extends IgcHTMLElement {
        createImplementation() {
            return new DashboardTileCustomization();
        }
        /**
         * @hidden
         */
        get i() {
            return this._implementation;
        } /**
                                     * @hidden
                                     */
        static _createFromInternal(internal) {
            if (!internal) {
                return null;
            }
            if (!internal.$type) {
                return null;
            }
            let name = internal.$type.name;
            let externalName = "Igc" + name + "Component";
            if (!TypeRegistrar.isRegistered(externalName)) {
                return null;
            }
            return TypeRegistrar.create(externalName);
        }
        onImplementationCreated() {
        }
        constructor() {
            super();
            this._settingAttributes = false;
            this._attached = false;
            this._queuedSetAttributes = [];
            this._updatingFromAttribute = false;
            this.__p = null;
            this._hasUserValues = new Set();
            this._stylingContainer = null;
            this._stylingParent = null;
            this._inStyling = false;
            if (this._styling) {
                NamePatcher.ensureStylablePatched(Object.getPrototypeOf(this));
            }
            this._implementation = this.createImplementation();
            this._implementation.externalObject = this;
            this.onImplementationCreated();
            if (this._initializeAdapters) {
                this._initializeAdapters();
            }
        }
        _enqueueSetAttribute(attrName, attrValue) {
            this._queuedSetAttributes.push({ attrName: attrName, attrValue: attrValue });
        }
        _flushQueuedAttributes() {
            this._settingAttributes = true;
            for (let i = 0; i < this._queuedSetAttributes.length; i++) {
                this.setAttribute(this._queuedSetAttributes[i].attrName, this._queuedSetAttributes[i].attrValue);
            }
            this._settingAttributes = false;
            this._queuedSetAttributes.length = 0;
        }
        _a(attrName, attrValue) {
            if (this._updatingFromAttribute) {
                return;
            }
            if (attrValue) {
                attrValue = attrValue.toString();
            }
            this._settingAttributes = true;
            attrName = toSpinal(attrName);
            if (this._attached) {
                this.setAttribute(attrName, attrValue);
            }
            else {
                this._enqueueSetAttribute(attrName, attrValue);
            }
            this._settingAttributes = false;
        }
        connectedCallback() {
            if (super["connectedCallback"]) {
                super["connectedCallback"]();
            }
            if (this.i.connectedCallback) {
                this.i.connectedCallback();
            }
            if (!this._attached) {
                this._attached = true;
                this._flushQueuedAttributes();
            }
        }
        disconnectedCallback() {
            if (super["disconnectedCallback"]) {
                super["disconnectedCallback"]();
            }
            if (this.i.disconnectedCallback) {
                this.i.disconnectedCallback();
            }
            if (this._attached) {
                this._attached = false;
            }
        }
        static get observedAttributes() {
            if (IgcDashboardTileCustomizationComponent._observedAttributesIgcDashboardTileCustomizationComponent == null) {
                let names = getAllPropertyNames(IgcDashboardTileCustomizationComponent);
                for (let i = 0; i < names.length; i++) {
                    names[i] = toSpinal(names[i]);
                }
                IgcDashboardTileCustomizationComponent._observedAttributesIgcDashboardTileCustomizationComponent = names;
            }
            return IgcDashboardTileCustomizationComponent._observedAttributesIgcDashboardTileCustomizationComponent;
        }
        attributeChangedCallback(name, oldValue, newValue) {
            if (this._settingAttributes) {
                return;
            }
            let setName = fromSpinal(name);
            this._updatingFromAttribute = true;
            this[setName] = newValue;
            this._updatingFromAttribute = false;
        }
        static register() {
            if (!IgcDashboardTileCustomizationComponent._isElementRegistered) {
                IgcDashboardTileCustomizationComponent._isElementRegistered = true;
                RegisterElementHelper.registerElement(IgcDashboardTileCustomizationComponent.htmlTagName, IgcDashboardTileCustomizationComponent);
            }
        }
        get matchType() {
            return this.i.l;
        }
        set matchType(v) {
            this.i.l = v;
        }
        get propertyName() {
            return this.i.m;
        }
        set propertyName(v) {
            this.i.m = v;
        }
        get propertyValue() {
            return this.i.k;
        }
        set propertyValue(v) {
            this.i.k = v;
        }
        get isCollectionInsertionAtEnd() {
            return this.i.c;
        }
        set isCollectionInsertionAtEnd(v) {
            this.i.c = ensureBool(v);
            this._a("isCollectionInsertionAtEnd", this.i.c);
        }
        get isCollectionInsertionAtStart() {
            return this.i.e;
        }
        set isCollectionInsertionAtStart(v) {
            this.i.e = ensureBool(v);
            this._a("isCollectionInsertionAtStart", this.i.e);
        }
        get isCollectionInsertionAtIndex() {
            return this.i.d;
        }
        set isCollectionInsertionAtIndex(v) {
            this.i.d = ensureBool(v);
            this._a("isCollectionInsertionAtIndex", this.i.d);
        }
        get isCollectionRemovaltIndex() {
            return this.i.f;
        }
        set isCollectionRemovaltIndex(v) {
            this.i.f = ensureBool(v);
            this._a("isCollectionRemovaltIndex", this.i.f);
        }
        get collectionIndex() {
            return this.i.h;
        }
        set collectionIndex(v) {
            this.i.h = +v;
            this._a("collectionIndex", this.i.h);
        }
        get order() {
            return this.i.j;
        }
        set order(v) {
            this.i.j = +v;
            this._a("order", this.i.j);
        }
        get matchParentIndex() {
            return this.i.i;
        }
        set matchParentIndex(v) {
            this.i.i = +v;
            this._a("matchParentIndex", this.i.i);
        }
        findByName(name) {
            if (this.findEphemera) {
                if (name && name.indexOf("@@e:") == 0) {
                    return this.findEphemera(name);
                }
            }
            return null;
        }
        get hasUserValues() {
            return this._hasUserValues;
        }
        __m(propertyName) {
            if (!this._inStyling) {
                this._hasUserValues.add(propertyName);
            }
        }
        _styling(container, component, parent) {
            if (this._inStyling) {
                return;
            }
            this._inStyling = true;
            this._stylingContainer = container;
            this._stylingParent = component;
            let genericPrefix = "";
            let typeName = this.i.$type.name;
            if (typeName.indexOf("Xam") === 0) {
                typeName = typeName.substring(3);
            }
            genericPrefix = toSpinal("DashboardTileCustomizationComponent");
            let additionalPrefixes = [];
            let prefix = toSpinal(typeName);
            additionalPrefixes.push(prefix + "-");
            let b = this.i.$type.baseType;
            while (b && b.name != "Object" &&
                b.name != "Base" &&
                b.name != "Control" &&
                b.Name != "DependencyObject" &&
                b.Name != "FrameworkElement") {
                typeName = b.name;
                if (typeName.indexOf("Xam") === 0) {
                    typeName = typeName.substring(3);
                }
                let basePrefix = toSpinal(typeName);
                additionalPrefixes.push(basePrefix + "-");
                b = b.baseType;
            }
            if (parent) {
                let parentTypeName = parent.i.$type.name;
                if (parentTypeName.indexOf("Xam") === 0) {
                    parentTypeName = parentTypeName.substring(3);
                }
                let parentPrefix = toSpinal(parentTypeName);
                additionalPrefixes.push(parentPrefix + "-" + genericPrefix + "-");
                additionalPrefixes.push(parentPrefix + "-" + prefix + "-");
            }
            initializePropertiesFromCss(container, this, genericPrefix + "-", this.hasUserValues, false, additionalPrefixes);
            if (this._otherStyling) {
                this._otherStyling(container, component, parent);
            }
            this._inStyling = false;
        }
    }
    IgcDashboardTileCustomizationComponent._observedAttributesIgcDashboardTileCustomizationComponent = null;
    IgcDashboardTileCustomizationComponent.htmlTagName = "igc-dashboard-tile-customization";
    IgcDashboardTileCustomizationComponent._isElementRegistered = false;
    return IgcDashboardTileCustomizationComponent;
})();
