import { __extends } from "tslib";
import { IgcHTMLElement } from "igniteui-webcomponents-core";
import { DashboardTileCustomization } from "./DashboardTileCustomization";
import { TypeRegistrar } from "igniteui-webcomponents-core";
import { NamePatcher, getAllPropertyNames, fromSpinal, toSpinal, ensureBool, initializePropertiesFromCss } from "igniteui-webcomponents-core";
import { RegisterElementHelper } from "igniteui-webcomponents-core";
var IgcDashboardTileCustomizationComponent = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgcDashboardTileCustomizationComponent, _super);
    function IgcDashboardTileCustomizationComponent() {
        var _this = _super.call(this) || this;
        _this._settingAttributes = false;
        _this._attached = false;
        _this._queuedSetAttributes = [];
        _this._updatingFromAttribute = false;
        _this.__p = null;
        _this._hasUserValues = new Set();
        _this._stylingContainer = null;
        _this._stylingParent = null;
        _this._inStyling = false;
        if (_this._styling) {
            NamePatcher.ensureStylablePatched(Object.getPrototypeOf(_this));
        }
        _this._implementation = _this.createImplementation();
        _this._implementation.externalObject = _this;
        _this.onImplementationCreated();
        if (_this._initializeAdapters) {
            _this._initializeAdapters();
        }
        return _this;
    }
    IgcDashboardTileCustomizationComponent.prototype.createImplementation = function () {
        return new DashboardTileCustomization();
    };
    Object.defineProperty(IgcDashboardTileCustomizationComponent.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        } /**
                                     * @hidden
                                     */,
        enumerable: false,
        configurable: true
    });
    IgcDashboardTileCustomizationComponent._createFromInternal = function (internal) {
        if (!internal) {
            return null;
        }
        if (!internal.$type) {
            return null;
        }
        var name = internal.$type.name;
        var externalName = "Igc" + name + "Component";
        if (!TypeRegistrar.isRegistered(externalName)) {
            return null;
        }
        return TypeRegistrar.create(externalName);
    };
    IgcDashboardTileCustomizationComponent.prototype.onImplementationCreated = function () {
    };
    IgcDashboardTileCustomizationComponent.prototype._enqueueSetAttribute = function (attrName, attrValue) {
        this._queuedSetAttributes.push({ attrName: attrName, attrValue: attrValue });
    };
    IgcDashboardTileCustomizationComponent.prototype._flushQueuedAttributes = function () {
        this._settingAttributes = true;
        for (var i = 0; i < this._queuedSetAttributes.length; i++) {
            this.setAttribute(this._queuedSetAttributes[i].attrName, this._queuedSetAttributes[i].attrValue);
        }
        this._settingAttributes = false;
        this._queuedSetAttributes.length = 0;
    };
    IgcDashboardTileCustomizationComponent.prototype._a = function (attrName, attrValue) {
        if (this._updatingFromAttribute) {
            return;
        }
        if (attrValue) {
            attrValue = attrValue.toString();
        }
        this._settingAttributes = true;
        attrName = toSpinal(attrName);
        if (this._attached) {
            this.setAttribute(attrName, attrValue);
        }
        else {
            this._enqueueSetAttribute(attrName, attrValue);
        }
        this._settingAttributes = false;
    };
    IgcDashboardTileCustomizationComponent.prototype.connectedCallback = function () {
        if (_super.prototype["connectedCallback"]) {
            _super.prototype["connectedCallback"].call(this);
        }
        if (this.i.connectedCallback) {
            this.i.connectedCallback();
        }
        if (!this._attached) {
            this._attached = true;
            this._flushQueuedAttributes();
        }
    };
    IgcDashboardTileCustomizationComponent.prototype.disconnectedCallback = function () {
        if (_super.prototype["disconnectedCallback"]) {
            _super.prototype["disconnectedCallback"].call(this);
        }
        if (this.i.disconnectedCallback) {
            this.i.disconnectedCallback();
        }
        if (this._attached) {
            this._attached = false;
        }
    };
    Object.defineProperty(IgcDashboardTileCustomizationComponent, "observedAttributes", {
        get: function () {
            if (IgcDashboardTileCustomizationComponent._observedAttributesIgcDashboardTileCustomizationComponent == null) {
                var names = getAllPropertyNames(IgcDashboardTileCustomizationComponent);
                for (var i = 0; i < names.length; i++) {
                    names[i] = toSpinal(names[i]);
                }
                IgcDashboardTileCustomizationComponent._observedAttributesIgcDashboardTileCustomizationComponent = names;
            }
            return IgcDashboardTileCustomizationComponent._observedAttributesIgcDashboardTileCustomizationComponent;
        },
        enumerable: false,
        configurable: true
    });
    IgcDashboardTileCustomizationComponent.prototype.attributeChangedCallback = function (name, oldValue, newValue) {
        if (this._settingAttributes) {
            return;
        }
        var setName = fromSpinal(name);
        this._updatingFromAttribute = true;
        this[setName] = newValue;
        this._updatingFromAttribute = false;
    };
    IgcDashboardTileCustomizationComponent.register = function () {
        if (!IgcDashboardTileCustomizationComponent._isElementRegistered) {
            IgcDashboardTileCustomizationComponent._isElementRegistered = true;
            RegisterElementHelper.registerElement(IgcDashboardTileCustomizationComponent.htmlTagName, IgcDashboardTileCustomizationComponent);
        }
    };
    Object.defineProperty(IgcDashboardTileCustomizationComponent.prototype, "matchType", {
        get: function () {
            return this.i.l;
        },
        set: function (v) {
            this.i.l = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcDashboardTileCustomizationComponent.prototype, "propertyName", {
        get: function () {
            return this.i.m;
        },
        set: function (v) {
            this.i.m = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcDashboardTileCustomizationComponent.prototype, "propertyValue", {
        get: function () {
            return this.i.k;
        },
        set: function (v) {
            this.i.k = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcDashboardTileCustomizationComponent.prototype, "isCollectionInsertionAtEnd", {
        get: function () {
            return this.i.c;
        },
        set: function (v) {
            this.i.c = ensureBool(v);
            this._a("isCollectionInsertionAtEnd", this.i.c);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcDashboardTileCustomizationComponent.prototype, "isCollectionInsertionAtStart", {
        get: function () {
            return this.i.e;
        },
        set: function (v) {
            this.i.e = ensureBool(v);
            this._a("isCollectionInsertionAtStart", this.i.e);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcDashboardTileCustomizationComponent.prototype, "isCollectionInsertionAtIndex", {
        get: function () {
            return this.i.d;
        },
        set: function (v) {
            this.i.d = ensureBool(v);
            this._a("isCollectionInsertionAtIndex", this.i.d);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcDashboardTileCustomizationComponent.prototype, "isCollectionRemovaltIndex", {
        get: function () {
            return this.i.f;
        },
        set: function (v) {
            this.i.f = ensureBool(v);
            this._a("isCollectionRemovaltIndex", this.i.f);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcDashboardTileCustomizationComponent.prototype, "collectionIndex", {
        get: function () {
            return this.i.h;
        },
        set: function (v) {
            this.i.h = +v;
            this._a("collectionIndex", this.i.h);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcDashboardTileCustomizationComponent.prototype, "order", {
        get: function () {
            return this.i.j;
        },
        set: function (v) {
            this.i.j = +v;
            this._a("order", this.i.j);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcDashboardTileCustomizationComponent.prototype, "matchParentIndex", {
        get: function () {
            return this.i.i;
        },
        set: function (v) {
            this.i.i = +v;
            this._a("matchParentIndex", this.i.i);
        },
        enumerable: false,
        configurable: true
    });
    IgcDashboardTileCustomizationComponent.prototype.findByName = function (name) {
        if (this.findEphemera) {
            if (name && name.indexOf("@@e:") == 0) {
                return this.findEphemera(name);
            }
        }
        return null;
    };
    Object.defineProperty(IgcDashboardTileCustomizationComponent.prototype, "hasUserValues", {
        get: function () {
            return this._hasUserValues;
        },
        enumerable: false,
        configurable: true
    });
    IgcDashboardTileCustomizationComponent.prototype.__m = function (propertyName) {
        if (!this._inStyling) {
            this._hasUserValues.add(propertyName);
        }
    };
    IgcDashboardTileCustomizationComponent.prototype._styling = function (container, component, parent) {
        if (this._inStyling) {
            return;
        }
        this._inStyling = true;
        this._stylingContainer = container;
        this._stylingParent = component;
        var genericPrefix = "";
        var typeName = this.i.$type.name;
        if (typeName.indexOf("Xam") === 0) {
            typeName = typeName.substring(3);
        }
        genericPrefix = toSpinal("DashboardTileCustomizationComponent");
        var additionalPrefixes = [];
        var prefix = toSpinal(typeName);
        additionalPrefixes.push(prefix + "-");
        var b = this.i.$type.baseType;
        while (b && b.name != "Object" &&
            b.name != "Base" &&
            b.name != "Control" &&
            b.Name != "DependencyObject" &&
            b.Name != "FrameworkElement") {
            typeName = b.name;
            if (typeName.indexOf("Xam") === 0) {
                typeName = typeName.substring(3);
            }
            var basePrefix = toSpinal(typeName);
            additionalPrefixes.push(basePrefix + "-");
            b = b.baseType;
        }
        if (parent) {
            var parentTypeName = parent.i.$type.name;
            if (parentTypeName.indexOf("Xam") === 0) {
                parentTypeName = parentTypeName.substring(3);
            }
            var parentPrefix = toSpinal(parentTypeName);
            additionalPrefixes.push(parentPrefix + "-" + genericPrefix + "-");
            additionalPrefixes.push(parentPrefix + "-" + prefix + "-");
        }
        initializePropertiesFromCss(container, this, genericPrefix + "-", this.hasUserValues, false, additionalPrefixes);
        if (this._otherStyling) {
            this._otherStyling(container, component, parent);
        }
        this._inStyling = false;
    };
    IgcDashboardTileCustomizationComponent._observedAttributesIgcDashboardTileCustomizationComponent = null;
    IgcDashboardTileCustomizationComponent.htmlTagName = "igc-dashboard-tile-customization";
    IgcDashboardTileCustomizationComponent._isElementRegistered = false;
    return IgcDashboardTileCustomizationComponent;
}(IgcHTMLElement));
export { IgcDashboardTileCustomizationComponent };
