import { Base, Type, INotifyPropertyChanged, IEnumerable, PropertyChangedEventArgs } from "igniteui-webcomponents-core";
import { DomRenderer } from "igniteui-webcomponents-core";
import { List$1 } from "igniteui-webcomponents-core";
import { NativeUIContent } from "igniteui-webcomponents-core";
import { NativeUIGrid } from "igniteui-webcomponents-core";
import { AnimationKeyFrameEffect } from "igniteui-webcomponents-core";
import { AnimationKeyFrameEffectTiming } from "igniteui-webcomponents-core";
import { ComponentRenderer } from "igniteui-webcomponents-core";
import { DataSeriesToDescriptionCustomization } from "igniteui-webcomponents-core";
import { IToolbarTarget } from "igniteui-webcomponents-core";
import { IDomainChartLike } from "igniteui-webcomponents-charts";
import { IAcceptsDataSeriesToDescriptionCustomizations } from "igniteui-webcomponents-core";
import { DataSeriesAdapterImplementation } from "igniteui-webcomponents-core";
import { DataSeriesType } from "igniteui-webcomponents-core";
import { IDataSeriesAdapterRule } from "igniteui-webcomponents-core";
import { DashboardTileSortDescriptionCollection } from "./DashboardTileSortDescriptionCollection";
import { FilterExpressionCollection } from "igniteui-webcomponents-core";
import { DashboardTileSummaryDescriptionCollection } from "./DashboardTileSummaryDescriptionCollection";
import { DashboardTileFilterStringErrorsParsingEventArgs } from "./DashboardTileFilterStringErrorsParsingEventArgs";
import { TrendLineType } from "igniteui-webcomponents-core";
import { SeriesHighlightedValuesDisplayMode } from "igniteui-webcomponents-core";
import { DashboardTileVisualizationType } from "./DashboardTileVisualizationType";
import { BrushCollection } from "igniteui-webcomponents-core";
import { ChartSelectedItemCollection } from "igniteui-webcomponents-charts";
import { Brush } from "igniteui-webcomponents-core";
import { ValueModeCollection } from "igniteui-webcomponents-charts";
import { CrosshairsDisplayMode } from "igniteui-webcomponents-charts";
import { BaseControlTheme } from "igniteui-webcomponents-core";
import { ControlDisplayDensity } from "igniteui-webcomponents-core";
import { TypeDescriptionContext } from "igniteui-webcomponents-core";
import { ToolCommand } from "igniteui-webcomponents-core";
import { IExecutionContext } from "igniteui-webcomponents-core";
import { XamDataChart } from "igniteui-webcomponents-charts";
import { DataSeries } from "igniteui-webcomponents-core";
import { ICommandStateChangedListener } from "igniteui-webcomponents-core";
import { ObservableCollection$1 } from "igniteui-webcomponents-core";
import { DashboardTileChangingContentEventArgs } from "./DashboardTileChangingContentEventArgs";
import { DataPieChart } from "igniteui-webcomponents-charts";
import { Size } from "igniteui-webcomponents-core";
import { ToolActionInfo } from "igniteui-webcomponents-core";
import { IToolbarContextAccessor } from "igniteui-webcomponents-core";
import { DomainChartToolbarProvider } from "igniteui-webcomponents-charts";
import { ToolCommandExecutionState } from "igniteui-webcomponents-core";
import { ICommandAvailabilityListener } from "igniteui-webcomponents-core";
/**
 * @hidden
 */
export declare class DashboardTileView extends Base {
    static $t: Type;
    constructor();
    t(): void;
    static n(a: any): string;
    s(a: any, b: string): void;
    o(a: NativeUIGrid): void;
    a(a: NativeUIGrid, b: AnimationKeyFrameEffectTiming): AnimationKeyFrameEffect;
    b: DashboardTile;
    x(): void;
    f(): boolean;
    k: DomRenderer;
    private c;
    private j;
    v(a: DomRenderer): void;
    q(): void;
    private d;
    u(): void;
    w(): void;
    m(): any;
    r(a: NativeUIGrid): void;
    l(a: NativeUIContent): any;
    private i;
    private g;
    private h;
    y(a: NativeUIContent, b: string): void;
    private e;
    p(): void;
}
/**
 * @hidden
 */
export declare class DashboardTileCustomization extends Base {
    static $t: Type;
    constructor();
    l: string;
    m: string;
    k: any;
    c: boolean;
    e: boolean;
    d: boolean;
    f: boolean;
    h: number;
    j: number;
    i: number;
    g: (arg1: DashboardTile) => any;
    static a(a: DashboardTileCustomization): DataSeriesToDescriptionCustomization;
    static b(a: DataSeriesToDescriptionCustomization): DashboardTileCustomization;
}
/**
 * @hidden
 */
export declare class DashboardTile extends Base implements INotifyPropertyChanged, IToolbarTarget, IDomainChartLike, IAcceptsDataSeriesToDescriptionCustomizations {
    static $t: Type;
    a4: DashboardTileView;
    onAttachedToUI(): void;
    onDetachedFromUI(): void;
    private ck;
    get currentDataAdapter(): DataSeriesAdapterImplementation;
    private ci;
    private g;
    onCustomizationsChanged(a: DataSeriesToDescriptionCustomization[]): void;
    private gs;
    private ce;
    private ca;
    sendCommandCompleted(a: ToolCommand): void;
    captureTargetImageToClipboard(a: (arg1: any, arg2: any) => void): void;
    private hh;
    ab: DataSeriesAdapterImplementation;
    private aj;
    get customizations(): DashboardTileCustomizationCollection;
    private dq;
    protected get d0(): List$1<DataSeriesType>;
    private gn;
    private dp;
    protected get dz(): List$1<IDataSeriesAdapterRule>;
    ac: DataSeriesAdapterImplementation;
    constructor();
    private cq;
    private gt;
    private gu;
    private c7;
    private h3;
    private static a;
    private static e;
    private static f;
    private static b;
    private static d;
    private static c;
    private dj;
    private dl;
    private k;
    private hu;
    private ht;
    private dd;
    private dc;
    private hd;
    private hg;
    protected gw(): void;
    private e5;
    get ge(): string;
    set ge(a: string);
    private c4;
    private c3;
    private b9;
    hq(a: () => void, b: boolean): {
        p1?: boolean;
    };
    protected hp(): void;
    private cu;
    protected gq(): void;
    private g0;
    private hz;
    private go;
    protected fq(a: DataSeries): string;
    private dg;
    protected gx(): void;
    private e4;
    private dk;
    h2(a: string, b: any): void;
    er(a: string): any;
    ct(): boolean;
    gr(): void;
    hr(a: string): void;
    protected get db(): boolean;
    protected hs(): void;
    private ej;
    private ek;
    changingContent: (sender: any, args: DashboardTileChangingContentEventArgs) => void;
    private l;
    private aa;
    private c1;
    private c6;
    private c0;
    private c5;
    private cz;
    private c2;
    private cy;
    private cw;
    private ba;
    private bb;
    private bc;
    private g7;
    private dy;
    private h5;
    private gp;
    private hl;
    private g1;
    private hf;
    private cf;
    private hc;
    private ee;
    private get et();
    private set et(value);
    private ea;
    private get ei();
    private set ei(value);
    private eb;
    private get el();
    private set el(value);
    private _externalObject;
    get externalObject(): any;
    set externalObject(a: any);
    private ep;
    private hv;
    private eo;
    private en;
    private static bn;
    static get bo(): ComponentRenderer;
    private static f7;
    private hx;
    private hw;
    private hy;
    private ar;
    private an;
    private am;
    private bd;
    private be;
    private az;
    private bl;
    private bm;
    private aq;
    private ap;
    private ao;
    private bg;
    private bf;
    private ay;
    get aw(): DashboardTileSortDescriptionCollection;
    get av(): DashboardTileSortDescriptionCollection;
    get au(): DashboardTileSortDescriptionCollection;
    get bj(): FilterExpressionCollection;
    get bk(): FilterExpressionCollection;
    get a0(): DashboardTileSummaryDescriptionCollection;
    private e1;
    get f2(): string;
    set f2(a: string);
    private ex;
    get fr(): string;
    set fr(a: string);
    private ez;
    get fy(): string;
    set fy(a: string);
    private ey;
    get fw(): string;
    set fw(a: string);
    private e0;
    get f0(): string;
    set f0(a: string);
    filterStringErrorsParsing: (sender: any, args: DashboardTileFilterStringErrorsParsingEventArgs) => void;
    private e2;
    get f4(): string;
    set f4(a: string);
    get ax(): DashboardTileSortDescriptionCollection;
    get at(): DashboardTileSortDescriptionCollection;
    get as(): DashboardTileSortDescriptionCollection;
    get bh(): FilterExpressionCollection;
    get bi(): FilterExpressionCollection;
    get a1(): DashboardTileSummaryDescriptionCollection;
    ad(a: boolean): DataSeriesAdapterImplementation;
    private b7;
    private get b8();
    private ed;
    get itemsSource(): any;
    set itemsSource(a: any);
    private d9;
    get actualItemsSource(): any;
    set actualItemsSource(a: any);
    private ec;
    get highlightedItemsSource(): any;
    set highlightedItemsSource(a: any);
    private d8;
    get actualHighlightedItemsSource(): any;
    set actualHighlightedItemsSource(a: any);
    private cm;
    protected get_de(): boolean;
    protected set_de(a: boolean): void;
    get de(): boolean;
    set de(a: boolean);
    private cl;
    get shouldAvoidAxisAnnotationCollisions(): boolean;
    set shouldAvoidAxisAnnotationCollisions(a: boolean);
    private ag;
    get trendLineType(): TrendLineType;
    set trendLineType(a: TrendLineType);
    private static d1;
    private cn;
    protected get_df(): boolean;
    protected set_df(a: boolean): void;
    get df(): boolean;
    set df(a: boolean);
    private ae;
    protected get_af(): SeriesHighlightedValuesDisplayMode;
    protected set_af(a: SeriesHighlightedValuesDisplayMode): void;
    get af(): SeriesHighlightedValuesDisplayMode;
    set af(a: SeriesHighlightedValuesDisplayMode);
    private i;
    get includedProperties(): string[];
    set includedProperties(a: string[]);
    private j;
    get m(): DashboardTileVisualizationType[];
    set m(a: DashboardTileVisualizationType[]);
    private h;
    get excludedProperties(): string[];
    set excludedProperties(a: string[]);
    private q;
    get v(): BrushCollection;
    set v(a: BrushCollection);
    private r;
    get w(): BrushCollection;
    set w(a: BrushCollection);
    private _selectedSeriesItems;
    get selectedSeriesItems(): ChartSelectedItemCollection;
    set selectedSeriesItems(a: ChartSelectedItemCollection);
    private o;
    private static dn;
    private static dh;
    static dx(a: string, b: List$1<DashboardTileCustomization>): List$1<DashboardTileCustomization>;
    private static di;
    static ga(a: string, b: string): string;
    get t(): BrushCollection;
    set t(a: BrushCollection);
    private static dr;
    private p;
    get u(): BrushCollection;
    set u(a: BrushCollection);
    private static ds;
    private h7;
    get h9(): Brush;
    set h9(a: Brush);
    private static du;
    private ah;
    get valueLines(): ValueModeCollection;
    set valueLines(a: ValueModeCollection);
    private static d2;
    private s;
    get valueLinesBrushes(): BrushCollection;
    set valueLinesBrushes(a: BrushCollection);
    private static gj;
    private cb;
    get autoCalloutsVisible(): boolean;
    set autoCalloutsVisible(a: boolean);
    private static dt;
    private cc;
    get crosshairsAnnotationEnabled(): boolean;
    set crosshairsAnnotationEnabled(a: boolean);
    private static dv;
    private static cr;
    private static cv;
    private cj;
    get finalValueAnnotationsVisible(): boolean;
    set finalValueAnnotationsVisible(a: boolean);
    private static dw;
    private z;
    get crosshairsDisplayMode(): CrosshairsDisplayMode;
    set crosshairsDisplayMode(a: CrosshairsDisplayMode);
    private static fg;
    private a5;
    get a6(): DashboardTileVisualizationType;
    set a6(a: DashboardTileVisualizationType);
    private d5;
    get d7(): number;
    set d7(a: number);
    notifyContainerResized(): void;
    ha(a: Size): void;
    private bs;
    get bt(): BaseControlTheme;
    set bt(a: BaseControlTheme);
    private bu;
    get bv(): ControlDisplayDensity;
    set bv(a: ControlDisplayDensity);
    private h6;
    get h8(): Brush;
    set h8(a: Brush);
    protected ev(): any;
    private d6;
    private da;
    protected eu(): any;
    protected get_cx(): boolean;
    protected get cx(): boolean;
    protected d3(): IEnumerable;
    g2(a: (arg1: XamDataChart) => void): void;
    g4(a: (arg1: DataPieChart) => void): void;
    private g5;
    private g3;
    zoomIn(a: number): void;
    zoomOut(a: number): void;
    resetZoom(): void;
    protected x(a: BrushCollection): BrushCollection;
    notifySizeChanged(): void;
    hk(): void;
    hj(): void;
    private ew;
    private get fi();
    private bx;
    private by;
    static get bp(): TypeDescriptionContext;
    destroy(): void;
    private eh;
    provideContainer(a: DomRenderer): void;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    protected hi(a: string, b: any, c: any): void;
    protected hn(a: string, b: any, c: any): void;
    private h4;
    private static cs;
    private a2;
    private get a3();
    getDesiredToolbarActions(): ToolActionInfo[];
    private eq;
    onToolCommandExecuting(a: ToolCommand): ToolCommandExecutionState;
    private _commandCompleted;
    get commandCompleted(): (arg1: ToolCommand) => void;
    set commandCompleted(a: (arg1: ToolCommand) => void);
    private _invalidateActions;
    get invalidateActions(): () => void;
    set invalidateActions(a: () => void);
    private bw;
    provideContextAccessor(a: IToolbarContextAccessor): void;
    g6(): void;
    addCommandAvailabilityListener(a: ICommandAvailabilityListener): void;
    removeCommandAvailabilityListener(a: ICommandAvailabilityListener): void;
    private dm;
    addCommandStateChangedListener(a: ICommandStateChangedListener): void;
    removeCommandStateChangedListener(a: ICommandStateChangedListener): void;
    h1(): void;
    private co;
    private d4;
    h0(): void;
    private ia;
    private ch;
    private cg;
    private gy;
    private hm;
    private get n();
    private gz;
    private bq;
    private b4;
    private b3;
    private b6;
    private b0;
    private b2;
    private b5;
    private b1;
    private e3;
    private cp;
    private a9;
    private a8;
    private cd;
    private a7;
    private bz;
    get br(): IExecutionContext;
    set br(a: IExecutionContext);
    get c9(): boolean;
    get c8(): boolean;
}
/**
 * @hidden
 */
export declare class DashboardTileCustomizationCollection extends ObservableCollection$1<DashboardTileCustomization> {
    static $t: Type;
    constructor();
}
/**
 * @hidden
 */
export declare class DashboardTileToolbarProvider extends DomainChartToolbarProvider {
    static $t: Type;
    private static af;
    constructor();
    private static ah;
    private static ag;
    private static co;
    static readonly cm: string;
    static readonly ai: string;
    static readonly ak: string;
    static readonly am: string;
    static readonly ao: string;
    static readonly aq: string;
    static readonly as: string;
    static readonly bq: string;
    static readonly au: string;
    static readonly aw: string;
    static readonly ay: string;
    static readonly a2: string;
    static readonly a4: string;
    static readonly a8: string;
    static readonly a6: string;
    static readonly ba: string;
    static readonly bc: string;
    static readonly be: string;
    static readonly bg: string;
    static readonly bi: string;
    static readonly bk: string;
    static readonly bm: string;
    static readonly bo: string;
    static readonly bs: string;
    static readonly bw: string;
    static readonly bu: string;
    static readonly by: string;
    static readonly b0: string;
    static readonly b2: string;
    static readonly b4: string;
    static readonly b6: string;
    static readonly b8: string;
    static readonly ca: string;
    static readonly cc: string;
    static readonly ce: string;
    static readonly cg: string;
    static readonly ci: string;
    static readonly ck: string;
    static readonly a0: string;
    private cp;
    getDesiredToolbarActions(a: IDomainChartLike, b: ToolActionInfo[], c: IToolbarContextAccessor): ToolActionInfo[];
    private ae;
    protected h(a: IDomainChartLike, b: ToolActionInfo): void;
    protected aa(a: IDomainChartLike, b: string, c: any, d: any): void;
    onToolCommandExecuting(a: IDomainChartLike, b: ToolCommand): ToolCommandExecutionState;
    protected q(a: IDomainChartLike, b: ToolCommand): void;
}
