import { DashboardTile } from "./DashboardTile";
import { ControlDisplayDensity } from "igniteui-webcomponents-core";
import { BaseControlTheme } from "igniteui-webcomponents-core";
import { IgcHTMLElement } from "igniteui-webcomponents-core";
import { IgcDashboardTileFilterStringErrorsParsingEventArgs } from "./igc-dashboard-tile-filter-string-errors-parsing-event-args";
import { ICommandStateChangedListener } from "igniteui-webcomponents-core";
import { ICommandAvailabilityListener } from "igniteui-webcomponents-core";
import { ToolActionInfo } from "igniteui-webcomponents-core";
import { DashboardTileVisualizationType } from "./DashboardTileVisualizationType";
import { CrosshairsDisplayMode } from "igniteui-webcomponents-charts";
import { IgcValueModeCollection } from "igniteui-webcomponents-charts";
import { IgcChartSelectedItemCollection } from "igniteui-webcomponents-charts";
import { SeriesHighlightedValuesDisplayMode } from "igniteui-webcomponents-core";
import { TrendLineType } from "igniteui-webcomponents-core";
import { IgcDashboardTileSummaryDescriptionCollection } from "./igc-dashboard-tile-summary-description-collection";
import { IgcFilterExpressionCollection } from "igniteui-webcomponents-core";
import { IgcDashboardTileSortDescriptionCollection } from "./igc-dashboard-tile-sort-description-collection";
import { IgcDashboardTileCustomizationComponent } from "./igc-dashboard-tile-customization-component";
import { IgcDashboardTileCustomizationCollection } from "./igc-dashboard-tile-customization-collection";
import { IgcDashboardTileChangingContentEventArgs } from "./igc-dashboard-tile-changing-content-event-args";
export declare class IgcDashboardTileComponent extends IgcHTMLElement {
    private _height;
    private _width;
    set height(value: string);
    get height(): string;
    set width(value: string);
    get width(): string;
    notifyContainerResized(): void;
    private _portalManager;
    private _container;
    private _renderer;
    constructor();
    private _onChildrenChanged;
    updateStyle(): void;
    destroy(): void;
    private _wrapper;
    protected createImplementation(): DashboardTile;
    private _DashboardTile;
    private _disconnected;
    disconnectedCallback(): void;
    connectedCallback(): void;
    afterContentInit(): void;
    protected _implementation: any;
    /**
     * @hidden
     */
    get i(): DashboardTile; /**
                                 * @hidden
                                 */
    static _createFromInternal(internal: any): IgcDashboardTileComponent;
    private _settingAttributes;
    protected _attached: boolean;
    private _queuedSetAttributes;
    protected _enqueueSetAttribute(attrName: string, attrValue: string): void;
    protected _flushQueuedAttributes(): void;
    protected _a(attrName: string, attrValue: any): void;
    private static _observedAttributesIgcDashboardTileComponent;
    static get observedAttributes(): string[];
    private _updatingFromAttribute;
    attributeChangedCallback(name: string, oldValue: string, newValue: string): void;
    static htmlTagName: string;
    protected static _isElementRegistered: boolean;
    static register(): void;
    private _customizations;
    private _actualCustomizations;
    get actualCustomizations(): IgcDashboardTileCustomizationComponent[];
    private _contentCustomizations;
    get contentCustomizations(): IgcDashboardTileCustomizationComponent[];
    private _customizationsAdapter;
    /**
     * Gets a collection where you can add customization that will be applied to the generated visualizations.
    */
    get customizations(): IgcDashboardTileCustomizationCollection;
    /**
     * Gets or sets text to display above the plot area.
    */
    get tileTitle(): string;
    set tileTitle(v: string);
    /**
     * Gets the initial sorts that are applied to the chart.
    */
    get initialSortDescriptions(): IgcDashboardTileSortDescriptionCollection;
    /**
     * Gets the initial sorts that are applied to the chart after groupings and summaries are applied.
    */
    get initialGroupSortDescriptions(): IgcDashboardTileSortDescriptionCollection;
    /**
     * Gets the initial groupings that are applied to the chart.
    */
    get initialGroupDescriptions(): IgcDashboardTileSortDescriptionCollection;
    /**
     * Gets the initial filters that are applied to the chart.
    */
    get initialFilterExpressions(): IgcFilterExpressionCollection;
    /**
     * Gets the initial highlight filters that are applied to the chart.
    */
    get initialHighlightFilterExpressions(): IgcFilterExpressionCollection;
    /**
     * Gets the initial summaries that are applied to the chart.
    */
    get initialSummaryDescriptions(): IgcDashboardTileSummaryDescriptionCollection;
    /**
     * Gets or sets the sorts to apply to the chart. This property will become ignored if sorts are changed outside of this property.
    */
    get initialSorts(): string;
    set initialSorts(v: string);
    /**
     * Gets or sets the sorts to apply after grouping has been applied.
    */
    get groupSorts(): string;
    set groupSorts(v: string);
    /**
     * Gets or sets the groupings to apply to the chart. This property will become ignored if sorts are changed outside of this property.
    */
    get initialGroups(): string;
    set initialGroups(v: string);
    /**
     * Gets or sets the filter to apply to the chart. This property will become ignored if the filter is changed outside of this property.
    */
    get initialFilter(): string;
    set initialFilter(v: string);
    /**
     * Gets or sets the filter to apply to the chart. This property will become ignored if the filter is changed outside of this property.
    */
    get initialHighlightFilter(): string;
    set initialHighlightFilter(v: string);
    /**
     * Gets or sets the summaries to apply to the chart. This property will become ignored if sorts are changed outside of this property.
    */
    get initialSummaries(): string;
    set initialSummaries(v: string);
    /**
     * Gets the current sort that is applied to the grid. Collection can be updated to modify the sort for the grid. Once sort descriptions are in this collection, the grid will no longer listen for changes on their properties.
    */
    get sortDescriptions(): IgcDashboardTileSortDescriptionCollection;
    get groupSortDescriptions(): IgcDashboardTileSortDescriptionCollection;
    /**
     * Gets the current grouping that is applied to the grid. Collection can be updated to modify the grouping for the grid. Once grouping descriptions are in this collection, the grid will no longer listen for changes on their properties.
    */
    get groupDescriptions(): IgcDashboardTileSortDescriptionCollection;
    /**
     * Gets the current filter that is applied to the chart. Collection can be updated to modify the filter for the chart. Once filter expressions are in this collection, the chart will no longer listen for changes on their properties.
    */
    get filterExpressions(): IgcFilterExpressionCollection;
    /**
     * Gets the current highlight filter that is applied to the chart. Collection can be updated to modify the highlight filter for the chart. Once filter expressions are in this collection, the chart will no longer listen for changes on their properties.
    */
    get highlightFilterExpressions(): IgcFilterExpressionCollection;
    /**
     * Gets the current summaries that are applied to the grid.
    */
    get summaryDescriptions(): IgcDashboardTileSummaryDescriptionCollection;
    /**
     * Gets or sets a collection of data items used to generate the dashboard tile.
     * The ItemsSource of this dashboard tile can be a list of objects containing one or more numeric properties.
     * Additionally, if the objects in the list implement an enumerable interface,
     * the dashboard tile will attempt to delve into the sub-collections when reading through the data source.
     * Data binding can be further configured by attributing the data item classes
     * with the data intent feature.
    */
    get dataSource(): any;
    set dataSource(v: any);
    /**
     * Gets or sets a collection of data items used to generate the dashboard tile.
     * The HighlightedItemsSource of this dashboard tile can be a list of objects containing one or more numeric properties.
     * Additionally, if the objects in the list implement an enumerable interface,
     * the dashboard tile will attempt to delve into the sub-collections when reading through the data source.
     * Data binding can be further configured by attributing the data item classes
     * with the data intent feature.
    */
    get highlightedDataSource(): any;
    set highlightedDataSource(v: any);
    /**
     * Gets or sets whether the dashboard tile should display mock data when the data source has not been provided, if supported for this type of chart.
    */
    get shouldDisplayMockData(): boolean;
    set shouldDisplayMockData(v: boolean);
    /**
     * Gets or sets whether annotations for the final value of each series is displayed on the axis.
    */
    get shouldAvoidAxisAnnotationCollisions(): boolean;
    set shouldAvoidAxisAnnotationCollisions(v: boolean);
    /**
     * Gets or sets the formula used for calculating trend lines in this chart.
     * This property applies only to these chart types: point, line, spline, and bubble
    */
    get trendLineType(): TrendLineType;
    set trendLineType(v: TrendLineType);
    /**
     * Gets or sets whether the dashboard tile should use a faded skeleton style for mock data.
    */
    get shouldUseSkeletonStyleForMockData(): boolean;
    set shouldUseSkeletonStyleForMockData(v: boolean);
    /**
     * Gets or sets whether and how to display highlighted values for the series. Note, this is distinct from the highlighting feature that indicates what is closest or under the mouse.
     * This property applies to Category Chart and Financial Chart controls.
    */
    get highlightedValuesDisplayMode(): SeriesHighlightedValuesDisplayMode;
    set highlightedValuesDisplayMode(v: SeriesHighlightedValuesDisplayMode);
    /**
     * Gets or sets a set of property paths that should be included for consideration by the category chart, leaving the remainder excluded. If null, all properties will be considered.
    */
    get includedProperties(): string[];
    set includedProperties(v: string[]);
    /**
     * Gets the current set of valid visualization types for the data.
    */
    get validVisualizationTypes(): DashboardTileVisualizationType[];
    set validVisualizationTypes(v: DashboardTileVisualizationType[]);
    /**
     * Gets or sets a set of property paths that should be excluded from consideration by the category chart.
    */
    get excludedProperties(): string[];
    set excludedProperties(v: string[]);
    /**
     * Gets or sets the palette of brushes to use for coloring the dashboard tile.
     * The value provided should be an array of CSS color strings or JavaScript objects defining gradients. Optionally the first element can be a string reading "RGB" or "HSV" to specify the interpolation mode of the collection
    */
    get brushes(): string[];
    set brushes(v: string[]);
    /**
     * Gets or sets the palette of brushes to use for outlines on the dashboard tile.
     * The value provided should be an array of CSS color strings or JavaScript objects defining gradients. Optionally the first element can be a string reading "RGB" or "HSV" to specify the interpolation mode of the collection
    */
    get outlines(): string[];
    set outlines(v: string[]);
    private _selectedSeriesItems;
    /**
     * Gets the currently selected data items.  Adding or removing data items from this collection will
     * select or deselect the visuals associated with those items.
    */
    get selectedSeriesItems(): IgcChartSelectedItemCollection;
    set selectedSeriesItems(v: IgcChartSelectedItemCollection);
    /**
     * Gets the actual palette of brushes to use for coloring the chart series.
    */
    get actualBrushes(): string[];
    set actualBrushes(v: string[]);
    /**
     * Gets the actual palette of brushes to use for outlines on the chart series.
    */
    get actualOutlines(): string[];
    set actualOutlines(v: string[]);
    /**
     * Gets the brush to use for the Category axis major strokes, if applicable.
    */
    get categoryAxisMajorStroke(): string;
    set categoryAxisMajorStroke(v: string);
    private _valueLines;
    /**
     * Gets or sets what value lines to use in the chart.
    */
    get valueLines(): IgcValueModeCollection;
    set valueLines(v: IgcValueModeCollection);
    /**
     * Gets or sets the palette of brushes to use for coloring the value lines present in the ValueLines property.
     * The value provided should be an array of CSS color strings or JavaScript objects defining gradients. Optionally the first element can be a string reading "RGB" or "HSV" to specify the interpolation mode of the collection
    */
    get valueLinesBrushes(): string[];
    set valueLinesBrushes(v: string[]);
    /**
     * Gets or sets if the auto value callouts should be displayed.
    */
    get autoCalloutsVisible(): boolean;
    set autoCalloutsVisible(v: boolean);
    /**
     * Gets or sets whether annotations are shown along the axis for crosshair values
    */
    get crosshairsAnnotationEnabled(): boolean;
    set crosshairsAnnotationEnabled(v: boolean);
    /**
     * Gets or sets whether annotations for the final value of each series is displayed on the axis.
    */
    get finalValueAnnotationsVisible(): boolean;
    set finalValueAnnotationsVisible(v: boolean);
    /**
     * Gets or sets the crosshairs to be displayed.
    */
    get crosshairsDisplayMode(): CrosshairsDisplayMode;
    set crosshairsDisplayMode(v: CrosshairsDisplayMode);
    /**
     * Gets or sets the crosshairs to be displayed.
    */
    get visualizationType(): DashboardTileVisualizationType;
    set visualizationType(v: DashboardTileVisualizationType);
    /**
     * Gets or sets the crosshairs to be displayed.
    */
    get validVisualizationTypePriorityThreshold(): number;
    set validVisualizationTypePriorityThreshold(v: number);
    /**
     * Gets or sets the base built in theme to use for the checkbox.
    */
    get baseTheme(): BaseControlTheme;
    set baseTheme(v: BaseControlTheme);
    /**
     * Gets or sets the display density to use for the toolbar.
    */
    get density(): ControlDisplayDensity;
    set density(v: ControlDisplayDensity);
    /**
     * Gets or sets the color to use for the background of the component.
    */
    get backgroundColor(): string;
    set backgroundColor(v: string);
    get isVisTypeStacked(): boolean;
    get isVisTypeRadial(): boolean;
    findByName(name: string): any;
    protected __p: string;
    protected _hasUserValues: Set<string>;
    protected get hasUserValues(): Set<string>;
    protected __m(propertyName: string): void;
    protected _stylingContainer: any;
    protected _stylingParent: any;
    protected _inStyling: boolean;
    protected _styling(container: any, component: any, parent?: any): void;
    updateSettingsValue(key: string, value: any): void;
    getSettingsValue(key: string): any;
    hasModifiedSettings(): boolean;
    clearSettings(): void;
    removeSettingsValue(key: string): void;
    zoomIn(percentage: number): void;
    /**
     * Performs zoom out action on the chart by specified percentage of current window rect
    
    */
    zoomOut(percentage: number): void;
    /**
     * Resets the zoom level to default.
    
    */
    resetZoom(): void;
    onUIReady(): void;
    getDesiredToolbarActions(): ToolActionInfo[];
    addCommandAvailabilityListener(listener: ICommandAvailabilityListener): void;
    removeCommandAvailabilityListener(listener: ICommandAvailabilityListener): void;
    addCommandStateChangedListener(listener: ICommandStateChangedListener): void;
    removeCommandStateChangedListener(listener: ICommandStateChangedListener): void;
    private _changingContent;
    private _changingContent_wrapped;
    get changingContent(): (s: IgcDashboardTileComponent, e: IgcDashboardTileChangingContentEventArgs) => void;
    set changingContent(ev: (s: IgcDashboardTileComponent, e: IgcDashboardTileChangingContentEventArgs) => void);
    private _filterStringErrorsParsing;
    private _filterStringErrorsParsing_wrapped;
    get filterStringErrorsParsing(): (s: IgcDashboardTileComponent, e: IgcDashboardTileFilterStringErrorsParsingEventArgs) => void;
    set filterStringErrorsParsing(ev: (s: IgcDashboardTileComponent, e: IgcDashboardTileFilterStringErrorsParsingEventArgs) => void);
}
